﻿Ext.require('App.Const.Finances');
Ext.define('App.Control.Kivii.Finances.Paying.Account.Selector', {
    extend: 'System.Control.EntitySelector',
    entityType: 'Kivii.Finances.Entities.Account',
    xtype: 'App.Control.Kivii.Finances.Paying.Account.Selector',
    dataSource: '/Restful/Kivii.Finances.Entities.Account/QueryEx.json',
    filter: {
    	OwnerKvid:KiviiContext.CurrentMember.DepartmentKvid
    	// TypeIn: 'Deposit'
    },
    selModel: false,
    store: {
        autoLoad: true
    },
    tbar: [{
        xtype: 'searchField',
        reference: 'searchfield',
        flex: 1,
        labelWidth: 60,
        queryField: 'Name,SerialNumber',
        emptyText: '模糊搜索'
    }],
    columns: [{
        xtype: 'rownumberer'
    }, {
        text: '账号名称',
        dataIndex: 'Name',
        sortable: true,
        width: 120
    }, {
        text: '账户类型',
        dataIndex: 'Type',
        resizable: false,
        sortable: true,
        width: 90,
        renderer: '_renderType'
    }, {
        text: '账号',
        dataIndex: 'SerialNumber',
        width: 120
    }, {
        text: '账号所属',
        dataIndex: 'OwnerName',
        sortable: true,
        width: 120
    }, {
        text: '账户余额',
        dataIndex: 'Amount',
        align: 'right',
        resizable: false,
        width: 100,
        summaryType: 'sum',
        summaryRenderer: function(value, summaryData, dataIndex) {
            return Ext.String.format('{0}', value.toFixed(2));
        }
    }, {
        text: '币种单位',
        dataIndex: 'Currency',
        resizable: false,
        sortable: true,
        width: 90,
        renderer: '_renderCurrency'
    }, {
        text: '摘要',
        dataIndex: 'Summary',
        resizable: true,
        width: 150
    }, {
        text: '备注',
        dataIndex: 'Remark',
        resizable: false,
        minWidth: 100,
        flex: 1
    }],
    setOwner: function(_entity) {
    	let _view = this;
        let _refs = _view.getReferences();
        let _search = _refs.searchfield;
        _search.setValue(_entity.PayerName);
        let _searchFilter = {};
        _searchFilter.QueryKeys = _search.queryField;
        _searchFilter.QueryValues = _search.getRawValue();
        let _fields = _view.query('field[queryField]');
        for (let _i in _fields) {
            _field = _fields[_i];
            if (_field === _view) continue;
            if (!_field.queryField) continue;
            _value = _field.getRawValue();
            _searchFilter[_field.queryField] = _value;
        }
        _view.setSearchFilter(_searchFilter);
        _view.setFilter({
            TypeIn: 'Deposit',
            // OwnerKvid: _ownerKvid
        });
        _view.reload && _view.reload();
    },
    controller: {
        _renderCurrency: function(_value, _meta, _record, _rowIndex) {
            if (_value === 'CNY') {
                return '人民币';
            }
            if (_value === 'USD') {
                return '美元';
            }
            if (_value === 'EUR') {
                return '欧元';
            }
            return _value;
        },
        _renderType: function(_value, _meta, _record, _rowIndex) {
            if (_value === 'Cash') {
                return '现金账户';
            }
            if (_value === 'Pos') {
                return '刷卡账户';
            }
            if (_value === 'Bank') {
                return '银行账户';
            }
            if (_value === 'Deposit') {
                return '存款账户';
            }
            if (_value === 'Coupon') {
                return '优惠券';
            }
            if (_value === 'StoredCard') {
                return '储值卡';
            }
            if (_value === 'Biz') {
                return '业务账户';
            }
            if (_value === 'Balance') {
                return '系统平衡';
            }
            if (_value === 'Discount') {
                return '折扣账户';
            }
            return _value;
        }
    }
});