﻿using Kivii.Finances.Entities;
using Kivii.Linq;
using Kivii.Web;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Finances.Transforms
{
    [Api(Description = "开票申请查询")]
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class InvoiceApplyQueryEx : RestfulExecution<InvoiceApply>
    {
        #region QueryArgs
        public virtual int? Skip { get; set; }

        public virtual int? Take { get; set; }

        public virtual string OrderBy { get; set; }

        public string OrderByDesc { get; set; }

        public virtual string Include { get; set; }

        public virtual string Fields { get; set; }

        public string QueryKeys { get; set; }

        public string QueryValues { get; set; }

        #endregion

        public override object OnExecution(IRequest req, IResponse res)
        {
            var conn = KiviiContext.GetOpenedDbConnection<InvoiceApply>();
            var dynamicParams = Request.GetRequestParams();
            var autoQuery = Request.TryResolve<IAutoQueryDb>();
            autoQuery.IncludeTotal = true;
            var request = new RestfulQuery<InvoiceApply>();
            request = request.PopulateWith(this);
            var sqlExpress = autoQuery.CreateQuery(Request, conn, request, dynamicParams);
            sqlExpress.Where(o => o.OffsetKvid == Guid.Empty && o.OperateType != InvoiceApplyType.Related);
            var rtns = autoQuery.Execute(Request, conn, request, sqlExpress);
            return rtns;
        }
    }

    [RequiresAnyRole(SystemRoles.Everyone)]
    public class InvoiceApplyQuery : RestfulQuery<InvoiceApply>
    { }

    [RequiresAnyRole(SystemRoles.Everyone)]
    public class InvoiceApplyRead : RestfulRead<InvoiceApply>
    { }

    [RequiresAnyRole(SystemRoles.Everyone)]
    public class InvoiceApplyDetailQuery : RestfulQuery<InvoiceApplyDetail>
    { }
}
